
@echo OFF
cls
COLOR 0A

rem <PROGRAM-HEADER>
echo **************************************************
echo *                                                *
echo * RegRead 4                                      *
echo *                                                *
echo **************************************************
echo.
echo Description:
echo        Read Windows Registry.
echo.
echo --------------------------------------------------------------------------------
rem: Informations :
rem         Author   : Vincent Duvernet
rem         Company  : Nolm Informatique
rem         Web site : http://www.nolme.com
rem 
rem: Version :
rem         Creation Date     : 2015/10/07
rem         Last modification : 2015/10/07
rem         Script version    : 1.0
rem 
rem: History :
rem         1.0 (2015-10-07) : First version
rem 
rem: Bug report :
rem         None.
rem 
rem: Pre-required application(s) :
rem         Microsoft .NET framework 4.0
rem         Nolm Informatique Command Line Tools 4.x
rem 
rem: Windows compatibility :
rem         Workstations : XP SP3, Vista SP2, 7 SP1, 8, 10
rem         Server       : 2003 SP3, 2008 SP2, 2008 R2 SP2, 2012, 2012 R2
rem 
rem: Sources :
rem         None.
rem 
rem: Variables :
rem         Name                            Type       Visibility     Values / Comment
rem         ----------------------------------------------------------------------------------------------------------------
rem         g_strBatchPath                  String     Static         Current script directory.
rem         g_strCurrentDirectory           String     Static         Current directory when running this script.
rem         g_strCmdLineToolsFolder         String     Static         CmdLineTools binary folder. Change this variable to use other version of CmdLineTools.
rem         g_strInternalOutputFullFilename String     Static         Output filename for data exchange between application and script.
rem         g_strCommand%%NAME%%FullPath    String     Static         Full filename of CmdLineTools application. Replace %%NAME%% by AppVersion4, Is64Bits4...
rem 
rem         g_strRegistryPath               String     Temp           Registry path.
rem         g_strRegistryValue1             String     Temp           Registry value n1.
rem         g_strRegistryValue2             String     Temp           Registry value n2.
rem         g_strAppResult1                 String     Temp           Application result n1.
rem         g_strAppResult2                 String     Temp           Application result n2.
rem 
rem: Notes :
rem         None.
rem 
rem ************************************************************************************************************************
rem </PROGRAM-HEADER>

rem <INIT>
echo [Initialisation]
echo ----------------
echo.
setlocal enabledelayedexpansion
set g_strBatchPath=%~dp0
set g_strCurrentDirectory=%CD%
set g_strCmdLineToolsFolder=!g_strBatchPath!\..\bin
set g_strInternalOutputFullFilename=%TEMP%\Nolme_SDK_Output.log
set g_strTempFolder=!g_strBatchPath!\..\temp

set g_strCommandRegRead4FullPath=!g_strCmdLineToolsFolder!\RegRead4.exe

rem Display current directory
echo - Batch directory : 
echo !g_strBatchPath!
echo.
rem Display current directory
echo - Current directory : 
echo !g_strCurrentDirectory!
echo.
rem Display CmdLineTools directory
echo - CmdLineTools directory : 
echo !g_strCmdLineToolsFolder!
echo.

echo Initialization done.
echo.
rem </INIT>

rem <MAIN>
echo [Main]
echo ------
echo.

SET g_strRegistryPath=SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
SET g_strRegistryValue1=Common Startup
SET g_strRegistryValue2=Startup

ECHO Version 1:
ECHO ----------
ECHO All users common startup:
"!g_strCommandRegRead4FullPath!" -r HKLM -p "%g_strRegistryPath%" -v "%g_strRegistryValue1%" -x86
echo.

ECHO Current user startup :
"!g_strCommandRegRead4FullPath!" -r HKCU -p "%g_strRegistryPath%" -v "%g_strRegistryValue2%" -x86
echo.

ECHO Version 2:
ECHO ----------
ECHO All users common startup:
SET g_strArguments=-r HKLM -p "%g_strRegistryPath%" -v "%g_strRegistryValue1%" -x86
"!g_strCommandRegRead4FullPath!" %g_strArguments% > "%g_strInternalOutputFullFilename%"
set /p g_strAppResult1= < "%g_strInternalOutputFullFilename%"
ECHO Result 1 : "%g_strAppResult1%"
echo.

ECHO Current user startup :
SET g_strArguments=-r HKCU -p "%g_strRegistryPath%" -v "%g_strRegistryValue2%"
"!g_strCommandRegRead4FullPath!" %g_strArguments% > "%g_strInternalOutputFullFilename%"
set /p g_strAppResult2= < "%g_strInternalOutputFullFilename%"
ECHO Result 2 : "%g_strAppResult2%"
echo.

rem </MAIN>

rem <FOOTER>
echo.
echo [End of script]
echo ---------------
Pause
GOTO:EOF
rem </FOOTER>
rem ------------------------------------------------------------------------------------------------------------------------------------
rem ------------------------------------------------------------------------------------------------------------------------------------
rem --------------------------------------------         END OF FILE          ----------------------------------------------------------
rem ------------------------------------------------------------------------------------------------------------------------------------
rem ------------------------------------------------------------------------------------------------------------------------------------